<script>
  export let disabled;
  export let label = "";
  export let name = "";
  export let type;
  export let value = "";
  export let placeholder = "";
  export let required = "";

  const click = e => {
    if (e.target.type == "radio") {
      const input = e.target;
      const curr = input.closest(".row").querySelector(".checked input");

      const checked = input.parentNode.classList.toggle("checked");

      if (curr && curr != input) {
        curr.parentNode.classList.remove("checked");
        curr.checked = false;
      }

      if (!checked) {
        input.checked = false;
      }
    }
  };
</script>

<style>
  label {
    position: relative;
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: flex-start;

    padding: 0;
    cursor: pointer;
    color: #eee;
    user-select: none;

    transition: background 200ms, color 200ms;
    border-radius: 5px;
  }

  label.radio {
    background: #444;
    text-align: center;
    align-items: center;
    padding: 30px 40px;
  }
  label.number,
  label.submit {
    margin: 0 0 20px;
  }

  label.checked {
    background: #a4cf92;
    color: #212121;
  }

  input {
    display: block;
    margin: 5px 0 0;
    width: 100%;
    padding: 10px 20px;
    border: 0;
    box-shadow: unset;
    border-radius: 5px;
  }

  input[type="radio"] {
    z-index: -1;
    position: absolute;
    width: 0;
  }

  input[type="submit"] {
    background: #a4cf92;
    cursor: pointer;
  }

  @media (max-width: 560px) {
    label.radio {
      padding: 10px 20px;
    }
  }
</style>

<label class={type} on:click={click}>
  {label}
  <input {type} {name} {value} {placeholder} {disabled} {required} />
</label>
